<?php
    require_once 'objects.php';
    if (!$_POST) {
        die($template_builder->wrap_text("basic_error", $template_builder->retrieve_page("no_post")));
    }
    
    // prepare fields for database push
    // part 1: user-filled
    $name_field = $_POST["name"];
    $name = explode("#", $name_field)[0];
    $tripcode = explode("#", $name_field, 1)[1];
    $subject = $_POST["subject"];
    $email = $_POST['email'];
    $post = $_POST["text"];
    $files = $_FILES || array();
    
    // part 2: hidden/server dependent
    $tstamp = gmtime();
    $board = $_POST["board"];
    $thread = $_POST["thread_no"] || "";
    $is_new_thread = $_POST["new_thread"];
    $ip = $_SERVER["REMOTE_ADDR"];

    $tripcode = generate_tripcode($tripcode);

    if ($board == "") {
        die($template_builder->wrap_text("basic_error", "You didn't send a board parameter in your request."));
    }

    if (!check_board($board, $pdo)) {
        die($template_builder->wrap_text("basic_error", "The board you tried to post in doesn't exist."));
    }

    if (!$is_new_thread && ($thread_no == "" || !check_thread($board, $thread_no, $pdo))) {
        die($template_builder->wrap_text("basic_error", "The thread doesn't exist."));
    }
        

    // check for both global and board bans
    if (($ban = check_bans("", $ip, $logger, $pdo)) || ($ban = check_bans($board, $ip, $logger, $pdo))) {
        die($template_builder->fill_template('youre_banned_creep', array('reason' => $ban['reason'], 'expiry' => date("Y/m/d H:i:s P", $ban['expire']), 'posting_name' => $ban['posting_name'], 'post' => $ban['post'])));
    }

    if (!dnsblk_bypassed($ip)) {
        header("Location: dnsblk_captcha.php");
    }

    $opts = get_board_opts($board, $pdo);

    for ($i = 0; ($i < $opts['file_limit']) && ($i < count($files)); $i++) {
        if (array_search(shell_exec("file --mime-type -b ".$files[i]["tmp_name"]), explode(",", $opts["allowed_mimetypes"]))) {
            // mime type is allowed

            // TODO complete file upload
        } else {
            $logger->log_warn("POST", "User with IP ".$ip." tried to upload file ".$files[i]["name"]." with unsupported mime type on board /".$board."/.");
            die($template_builder->wrap_text("basic_error", "Your file ".$files[i]["name"]." does not have a supported mime-type for this board. Supported mimetypes are: ".$opts["allowed_mimetypes"]));
        }
    }

    // TODO complete posting

         

    

?>
