<?php
    function generate_tripcode($trip) {
        // Stalin code from https://github.com/ctrlcctrlv/infinity/blob/master/inc/functions.php
        
        $trip = mb_convert_encoding($trip, 'Shift_JIS', 'UTF-8');

        // generate salt
        $salt = substr($trip.'H..', 1, 2);
        $salt = preg_replace('/[^.-z]/', '.', $salt);
        $salt = strtr($salt, ':;<=>?@[\]^_`', 'ABCDEFGabcdef');

        $trip = '!'.substr(crypt($trip, $salt), -10);

        // secure trips are planned for a future release
        return $trip;
    }

    function check_bans($board, $ip, $logger, $pdo) {
        // Thanks to a kind anon (>>>/tech/595879) for fixing my shitty code.
        
        $cache_key = $board ? "ip_banlist_$board" : "ip_banlist";
        if (!($banlist = apc_fetch($cache_key))) {
            // Get from database
            $ips = $pdo->prepare("SELECT ip FROM banlist WHERE board = ?");
            $ips->execute([$board || ""]);

            apc_store($cache_key, ($banlist = $ips->fetchAll(PDO::FETCH_COLUMN)), 1200);

        }
        
        if (!array_search($ip, $banlist))
            return false;

        // user ip found

        $info = $pdo->prepare("SELECT * FROM banlist WHERE board = ? AND ip = ?");
        $info->execute([$board || "", $ip]);
        return $info->fetch(PDO::FETCH_ASSOC);
    }
            

?>
